CREATE VIEW MHP_OEE.VIEW___RESRCE__RESOURCE_PLC__PLC_CATEGORY__PLC_OBJECT AS 
(
  SELECT 
  RESOURCE_PLC.*,
  RESRCE.HANDLE AS HANDLE_RESRCE,
  RESRCE.SITE AS SITE_RESRCE, 
  RESRCE.RESRCE, 
  RESRCE.DESCRIPTION AS RESRCE_DES, 
  RESRCE.ASSET, 
  RESRCE.SUB_ASSET, 
  RESRCE.LINE_AREA, 
  RESRCE.WORK_AREA, 
  RESRCE.WORKSHOP, 
  RESRCE.ENABLED, 
  RESRCE.EQP_USER_ID, 
  RESRCE.CONFIGURED_PLC_INFO, 
  RESRCE.MODIFIED_DATE_TIME AS MODIFIED_DATE_TIME_RESRCE, 
  PLC_CATEGORY.DESCRIPTION AS PLC_CATEGORY_DESCRIPTION, 
  PLC_OBJECT.PLC_OBJECT_DESCRIPTION 
  FROM  RESOURCE_PLC 
  INNER JOIN RESRCE 
  ON RESOURCE_PLC.RESOURCE_BO = RESRCE.HANDLE
  INNER JOIN PLC_CATEGORY 
  ON RESOURCE_PLC.CATEGORY = PLC_CATEGORY.CATEGORY 
  AND RESOURCE_PLC.SITE = PLC_CATEGORY.SITE
  LEFT JOIN PLC_OBJECT 
  ON RESOURCE_PLC.PLC_OBJECT = PLC_OBJECT.PLC_OBJECT 
  AND RESOURCE_PLC.SITE = PLC_OBJECT.SITE
);

CREATE VIEW MHP_OEE.VIEW___REA_CODE_GROUP__REA_CODE__REA_CODE_RES_STATE__RES_STATE AS 
(
  SELECT 
  C.HANDLE,
  A.SITE, 
  A.REASON_CODE_GROUP, 
  A.DESCRIPTION AS REASON_CODE_GROUP_DES, 
  B.REASON_CODE, 
  B.DESCRIPTION AS REASON_CODE_DES, 
  D.STATE, 
  D.DESCRIPTION AS STATE_DES, 
  C.START_DATE_TIME, 
  C.END_DATE_TIME,
  C.MODIFIED_DATE_TIME
  FROM  REASON_CODE_GROUP AS A 
  INNER JOIN REASON_CODE AS B 
  ON  A.REASON_CODE_GROUP = B.REASON_CODE_GROUP AND A.SITE = B.SITE
  INNER JOIN REASON_CODE_RES_STATE AS C 
  ON B.HANDLE = C.REASON_CODE_BO
  INNER JOIN RESOURCE_STATE as D 
  ON C.RESOURCE_STATE_BO = D.HANDLE
  ORDER BY REASON_CODE_GROUP,REASON_CODE,STATE,START_DATE_TIME
);

CREATE VIEW  MHP_OEE.VIEW___RESRCE__WORK_CENTER__WORK_CENTER_SHIFT AS 
(
  SELECT 
  A.SITE,
  A.RESRCE, 
  B.WORK_CENTER,
  C.SHIFT,
  C.DESCRIPTION,
  C.ENABLED
  FROM RESRCE AS A
  INNER JOIN WORK_CENTER AS B 
  ON A.WORK_AREA = B.WORK_CENTER AND A.SITE = B.SITE 
  INNER JOIN WORK_CENTER_SHIFT AS C
  ON B.HANDLE = C.WORK_CENTER_BO
);

CREATE VIEW  MHP_OEE.VIEW___SCHEDULED_DOWN_PLAN__RESRCE__WORK_CENTER AS 
(
  SELECT 
  A.HANDLE,
  B.SITE,
  B.RESRCE, 
  B.ASSET,
  A.RESOURCE_BO,
  A.STRT,
  B.DESCRIPTION AS RESRCE_DES, 
  B.WORK_AREA, 
  C.DESCRIPTION AS WORK_AREA_DES, 
  B.LINE_AREA, 
  D.DESCRIPTION AS LINE_AREA_DES,
  A.START_DATE_TIME,
  A.END_DATE_TIME,
  A.REASON_CODE,
  A.MODIFIED_DATE_TIME,
  E.DESCRIPTION AS RESON_CODE_DES
  FROM SCHEDULED_DOWN_PLAN AS A 
  INNER JOIN RESRCE AS B 
  ON A.RESOURCE_BO = B.HANDLE
  INNER JOIN 
  WORK_CENTER AS C
  ON B.WORK_AREA = C.WORK_CENTER AND B.SITE = C.SITE
  INNER JOIN WORK_CENTER AS D
  ON  B.LINE_AREA = D.WORK_CENTER AND B.SITE = D.SITE
  LEFT JOIN REASON_CODE AS E
  ON A.REASON_CODE = E.REASON_CODE AND A.SITE = E.SITE
);

CREATE VIEW MHP_OEE.VIEW___ACT_PERM__ACT__USR__USR_GROUP__USR_GROUP_MEMBER AS 
(
	SELECT DISTINCT A.SITE,A.USER_ID,ACTIVITY.ACTIVITY,ACTIVITY_PERM.PERMISSION_MODE
	FROM ACTIVITY_PERM
	INNER JOIN (
		SELECT 
			USR.SITE,
			USR.USER_ID,
			USR.HANDLE AS USER_BO,
			USER_GROUP.HANDLE AS USER_GROUP_BO
		FROM USER_GROUP_MEMBER
		INNER JOIN USER_GROUP ON USER_GROUP.HANDLE = USER_GROUP_MEMBER.USER_GROUP_BO
		INNER JOIN USR ON USR.HANDLE = USER_GROUP_MEMBER.USER_BO		
	) AS A ON A.USER_GROUP_BO = ACTIVITY_PERM.USER_GROUP_BO
	INNER JOIN ACTIVITY ON ACTIVITY.HANDLE = ACTIVITY_PERM.ACTIVITY_BO
);

CREATE VIEW MHP_OEE.VIEW__STD_CYCLE_TIME___RESRCE__RESOURCE_TYPE_RESOURCE AS 
(
	SELECT 
	A.*,
	B.DESCRIPTION,
	B.ASSET,
	B.LINE_AREA,
	B.WORK_AREA,
	C.RESOURCE_TYPE_BO
	FROM  STD_CYCLE_TIME AS A
	LEFT JOIN RESRCE AS B
	ON A.RESRCE = B.RESRCE AND A.SITE = B.SITE
	LEFT JOIN RESOURCE_TYPE_RESOURCE AS C
	ON B.HANDLE = C.RESOURCE_BO
);